const {ccclass, property, menu} = cc._decorator;

/** 
 * 节点键值对
*/
@ccclass('KeyNode')
export class KeyNode {

    @property()
    key = ''

    @property(cc.Node)
    _node = null

    @property({type:cc.Node})
    get node(){
        return this._node
    }

    set node(node:cc.Node){
        this._node = node
        if (this.key.length <= 0) {
            this.key = node.name
        }
    }
}

function get(theKey:string):cc.Node|null;
function get<T extends cc.Component>(theKey:string, comp:{prototype: T}):T|null;
function get<T extends cc.Component>(theKey:string, comp?:{prototype: T}):T|cc.Node|null{
    let nd = null
    for (const {key, node} of this.dict) {
        if (key == theKey && node) {
            nd = node
            break
        }
    }
    if (comp) {
        return nd.getComponent(comp)
    }
    return nd
}


@ccclass
@menu('base/Dict')
export default class Dict extends cc.Component {

    @property([KeyNode])
    dict = []

    get = get
}
