
const {ccclass, property, menu, requireComponent, executeInEditMode} = cc._decorator;

/* 图块 */
@ccclass
@executeInEditMode
@requireComponent(cc.Sprite)
@menu("base/Tile")
export default class Tile extends cc.Component {

    @property(cc.Integer)
    _frameIdx = 0

    @property({
        type: cc.Integer
    })
    get frameIdx(){
        return this._frameIdx
    }

    set frameIdx(val){
        this._frameIdx = val
        this.upd()
    }

    @property
    grid = cc.v2(1,1)

    @property(cc.SpriteFrame)
    spriteFrame:cc.SpriteFrame = null

    _spriteFrame:cc.SpriteFrame = null

    onFocusInEditor(){
        this.upd()
    }

    onLoad(){
        this.upd()
    }

    upd(){
        let spriteFrame = this.spriteFrame
        if (!spriteFrame) {
            return
        }
        if (!this._spriteFrame || spriteFrame.name !== this._spriteFrame.name) {
            if(CC_EDITOR){
                this._spriteFrame = spriteFrame
            }else{
                this._spriteFrame = spriteFrame.clone()
            }
            let sprite = this.getComponent(cc.Sprite)
            sprite.spriteFrame = this._spriteFrame
        }
        let max = this._spriteFrame.getOriginalSize()
        let idx = Math.round(this.frameIdx)
        let x = idx % this.grid.x
        let y = Math.floor(idx / this.grid.x)
        let w = max.width/this.grid.x
        let h = max.height/this.grid.y
        let rect = cc.rect(
            x * w,
            y * h,
            w,
            h,
        )
        this._spriteFrame.setRect(rect)
        let sprite = this.getComponent(cc.Sprite)
        sprite.spriteFrame = this._spriteFrame
    }
}

